use nanomsg::{Socket, Protocol};
use std::io::{Read, Write};

use super::types::*;

pub const central_exchange_nmsg_listen_url: &str = "ipc:///tmp/central-exchange.ipc";
pub const central_exchange_nmsg_url: &str = "ipc:///tmp/central-exchange.ipc";
pub const dispatcher_nmsg_url: &str = "ipc:///tmp/dispatcher.ipc";


pub fn ce_test_push() -> anyhow::Result<()> {
    let mut ce_socket = Socket::new(Protocol::Push)?;
    let mut endpoint = ce_socket.connect(central_exchange_nmsg_url)?;

    let msg = CEMessage::UpdateTreeFirstLevel { node_id: 88 };

    let _ = ce_socket.write(serde_json::to_string(&msg)?.as_bytes());

    let _ = endpoint.shutdown();

    Ok(())
}


pub fn ce_pull() -> anyhow::Result<()> {
    let mut l_socket = Socket::new(Protocol::Pull)?;
    let _ = l_socket.bind(central_exchange_nmsg_listen_url)?;
    let mut request = String::new();

    println!("ce listening on {}", central_exchange_nmsg_listen_url);
    
    loop {
	match l_socket.read_to_string(&mut request) {
	    Ok(_) => { println!("Received: {}", request); },
	    Err(err) => {
		println!("Failed: {}", err);
		break;
	    }
	}
	request.clear();
    }
    
    Ok(())
}
